Index: src/Box.hpp
===================================================================
--- src/Box.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Box.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,114 @@
+/*
+ * Box.hpp
+ *
+ *  Created on: Jun 30, 2010
+ *      Author: crueger
+ */
+
+#ifndef BOX_HPP_
+#define BOX_HPP_
+
+class Matrix;
+class Vector;
+class Plane;
+
+#include <list>
+#include <vector>
+#include "LinearAlgebra/VectorSet.hpp"
+
+/**
+ * A simple class that can be used to store periodic Boxes
+ * in the form of a parallelepiped.
+ *
+ * Stores a matrix that can be used to translate from periodic
+ * [0,1) space as well as the inverse that is needed to
+ * translate back to that space.
+ */
+class Box
+{
+public:
+  typedef enum{
+    Wrap,
+    Bounce,
+    Ignore
+  } BoundaryCondition_t;
+
+  typedef vector<BoundaryCondition_t> Conditions_t;
+
+  Box();
+  Box(const Box&);
+  virtual ~Box();
+
+  /**
+   * Get the matrix describing the form of the parallelepiped
+   */
+  const Matrix &getM() const;
+
+  /**
+   * Get the inverse of the matrix M (see above).
+   */
+  const Matrix &getMinv() const;
+
+  /**
+   * Set the form of the parallelepiped.
+   */
+  void setM(Matrix);
+
+  Box &operator=(const Box&);
+  Box &operator=(const Matrix&);
+
+  /**
+   * Translate a point from [0,1) to the boxed space.
+   */
+  Vector translateIn(const Vector &point) const;
+
+  /**
+   * Translate a point from the boxed space to the [0,1) space.
+   */
+  Vector translateOut(const Vector &point) const;
+
+  /**
+   * Wrap a point so that it will lie within the space defined by the box.
+   */
+  Vector WrapPeriodically(const Vector &point) const;
+
+  /**
+   * Checks whether a given vector is inside the box.
+   */
+  bool isInside(const Vector &point) const;
+
+  /**
+   * Produce corresponding points in several adjacent boxes.
+   *
+   * n specifies the number of times the point is expanded.
+   * Carefull, needs O(n^3) time and produces as many vectors.
+   */
+  VECTORSET(std::list) explode(const Vector &point,int n) const;
+  VECTORSET(std::list) explode(const Vector &point) const;
+
+  /**
+   * Calculate the distance of two points in the periodic space
+   * defined by this box
+   */
+  double periodicDistanceSquared(const Vector &point1,const Vector &point2) const;
+
+  /**
+   * Calculate the distance of two points in the periodic space
+   * defined by this box
+   */
+  double periodicDistance(const Vector &point1,const Vector &point2) const;
+
+  const Conditions_t getConditions();
+  void setCondition(int,BoundaryCondition_t);
+
+  const vector<pair<Plane,Plane> > getBoundingPlanes();
+
+  void setCuboid(const Vector&);
+
+private:
+  Conditions_t conditions;
+  Matrix *M;    //!< Defines the layout of the box
+  Matrix *Minv; //!< Inverse of M to avoid recomputation
+};
+
+#endif /* BOX_HPP_ */
Index: src/CandidateForTesselation.cpp
===================================================================
--- src/CandidateForTesselation.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/CandidateForTesselation.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,182 @@
+/*
+ * CandidateForTesselation.cpp
+ *
+ *  Created on: Jul 29, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "CandidateForTesselation.hpp"
+
+#include <iostream>
+#include <iomanip>
+
+#include "BoundaryLineSet.hpp"
+#include "BoundaryPointSet.hpp"
+#include "TesselPoint.hpp"
+
+#include "Helpers/Assert.hpp"
+#include "Helpers/Info.hpp"
+//#include "Line.hpp"
+#include "linkedcell.hpp"
+#include "Helpers/Log.hpp"
+//#include "Plane.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "Helpers/Verbose.hpp"
+
+using namespace std;
+
+
+const double CandidateForTesselation::HULLEPSILON = 1e-9;
+
+
+/** Constructor of class CandidateForTesselation.
+ */
+CandidateForTesselation::CandidateForTesselation(BoundaryLineSet* line) :
+  BaseLine(line),
+  ThirdPoint(NULL),
+  T(NULL),
+  ShortestAngle(2. * M_PI),
+  OtherShortestAngle(2. * M_PI)
+{
+  Info FunctionInfo(__func__);
+}
+;
+
+/** Constructor of class CandidateForTesselation.
+ */
+CandidateForTesselation::CandidateForTesselation(TesselPoint *candidate, BoundaryLineSet* line, BoundaryPointSet* point, const Vector &OptCandidateCenter, const Vector &OtherOptCandidateCenter) :
+  BaseLine(line),
+  ThirdPoint(point),
+  T(NULL),
+  OptCenter(OptCandidateCenter),
+  OtherOptCenter(OtherOptCandidateCenter),
+  ShortestAngle(2. * M_PI),
+  OtherShortestAngle(2. * M_PI)
+{
+  Info FunctionInfo(__func__);
+};
+
+
+/** Destructor for class CandidateForTesselation.
+ */
+CandidateForTesselation::~CandidateForTesselation()
+{
+}
+;
+
+/** Checks validity of a given sphere of a candidate line.
+ * Sphere must touch all candidates and the baseline endpoints and there must be no other atoms inside.
+ * \param RADIUS radius of sphere
+ * \param *LC LinkedCell structure with other atoms
+ * \return true - sphere is valid, false - sphere contains other points
+ */
+bool CandidateForTesselation::CheckValidity(const double RADIUS, const LinkedCell *LC) const
+{
+  Info FunctionInfo(__func__);
+
+  const double radiusSquared = RADIUS * RADIUS;
+  list<const Vector *> VectorList;
+  VectorList.push_back(&OptCenter);
+  //VectorList.push_back(&OtherOptCenter);  // don't check the other (wrong) center
+
+  if (!pointlist.empty())
+    DoLog(1) && (Log() << Verbose(1) << "INFO: Checking whether sphere contains candidate list and baseline " << *BaseLine->endpoints[0] << "<->" << *BaseLine->endpoints[1] << " only ..." << endl);
+  else
+    DoLog(1) && (Log() << Verbose(1) << "INFO: Checking whether sphere with no candidates contains baseline " << *BaseLine->endpoints[0] << "<->" << *BaseLine->endpoints[1] << " only ..." << endl);
+  // check baseline for OptCenter and OtherOptCenter being on sphere's surface
+  for (list<const Vector *>::const_iterator VRunner = VectorList.begin(); VRunner != VectorList.end(); ++VRunner) {
+    for (int i = 0; i < 2; i++) {
+      const double distance = fabs((*VRunner)->DistanceSquared(BaseLine->endpoints[i]->node->getPosition()) - radiusSquared);
+      if (distance > HULLEPSILON) {
+        DoeLog(1) && (eLog() << Verbose(1) << "Endpoint " << *BaseLine->endpoints[i] << " is out of sphere at " << *(*VRunner) << " by " << distance << "." << endl);
+        return false;
+      }
+    }
+  }
+
+  // check Candidates for OptCenter and OtherOptCenter being on sphere's surface
+  for (TesselPointList::const_iterator Runner = pointlist.begin(); Runner != pointlist.end(); ++Runner) {
+    const TesselPoint *Walker = *Runner;
+    for (list<const Vector *>::const_iterator VRunner = VectorList.begin(); VRunner != VectorList.end(); ++VRunner) {
+      const double distance = fabs((*VRunner)->DistanceSquared(Walker->getPosition()) - radiusSquared);
+      if (distance > HULLEPSILON) {
+        DoeLog(1) && (eLog() << Verbose(1) << "Candidate " << *Walker << " is out of sphere at " << *(*VRunner) << " by " << distance << "." << endl);
+        return false;
+      } else {
+        DoLog(1) && (Log() << Verbose(1) << "Candidate " << *Walker << " is inside by " << distance << "." << endl);
+      }
+    }
+  }
+
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Checking whether sphere contains no others points ..." << endl);
+  bool flag = true;
+  for (list<const Vector *>::const_iterator VRunner = VectorList.begin(); VRunner != VectorList.end(); ++VRunner) {
+    // get all points inside the sphere
+    TesselPointList *ListofPoints = LC->GetPointsInsideSphere(RADIUS, (*VRunner));
+
+    DoLog(1) && (Log() << Verbose(1) << "The following atoms are inside sphere at " << (*VRunner) << ":" << endl);
+    for (TesselPointList::const_iterator Runner = ListofPoints->begin(); Runner != ListofPoints->end(); ++Runner)
+      DoLog(1) && (Log() << Verbose(1) << "  " << *(*Runner) << " with distance " << (*Runner)->distance(*(*VRunner)) << "." << endl);
+
+    // remove baseline's endpoints and candidates
+    for (int i = 0; i < 2; i++) {
+      DoLog(1) && (Log() << Verbose(1) << "INFO: removing baseline tesselpoint " << *BaseLine->endpoints[i]->node << "." << endl);
+      ListofPoints->remove(BaseLine->endpoints[i]->node);
+    }
+    for (TesselPointList::const_iterator Runner = pointlist.begin(); Runner != pointlist.end(); ++Runner) {
+      DoLog(1) && (Log() << Verbose(1) << "INFO: removing candidate tesselpoint " << *(*Runner) << "." << endl);
+      ListofPoints->remove(*Runner);
+    }
+    if (!ListofPoints->empty()) {
+      DoeLog(1) && (eLog() << Verbose(1) << "CheckValidity: There are still " << ListofPoints->size() << " points inside the sphere." << endl);
+      flag = false;
+      DoeLog(1) && (eLog() << Verbose(1) << "External atoms inside of sphere at " << *(*VRunner) << ":" << endl);
+      for (TesselPointList::const_iterator Runner = ListofPoints->begin(); Runner != ListofPoints->end(); ++Runner)
+        DoeLog(1) && (eLog() << Verbose(1) << "  " << *(*Runner) << " at distance " << setprecision(13) << (*Runner)->distance(*(*VRunner)) << setprecision(6) << "." << endl);
+
+      // check with animate_sphere.tcl VMD script
+      if (ThirdPoint != NULL) {
+        DoeLog(1) && (eLog() << Verbose(1) << "Check by: animate_sphere 0 " << BaseLine->endpoints[0]->Nr + 1 << " " << BaseLine->endpoints[1]->Nr + 1 << " " << ThirdPoint->Nr + 1 << " " << RADIUS << " " << OldCenter[0] << " " << OldCenter[1] << " " << OldCenter[2] << " " << (*VRunner)->at(0) << " " << (*VRunner)->at(1) << " " << (*VRunner)->at(2) << endl);
+      } else {
+        DoeLog(1) && (eLog() << Verbose(1) << "Check by: ... missing third point ..." << endl);
+        DoeLog(1) && (eLog() << Verbose(1) << "Check by: animate_sphere 0 " << BaseLine->endpoints[0]->Nr + 1 << " " << BaseLine->endpoints[1]->Nr + 1 << " ??? " << RADIUS << " " << OldCenter[0] << " " << OldCenter[1] << " " << OldCenter[2] << " " << (*VRunner)->at(0) << " " << (*VRunner)->at(1) << " " << (*VRunner)->at(2) << endl);
+      }
+    }
+    delete (ListofPoints);
+
+  }
+  return flag;
+}
+;
+
+/** output operator for CandidateForTesselation.
+ * \param &ost output stream
+ * \param &a boundary line
+ */
+ostream & operator <<(ostream &ost, const CandidateForTesselation &a)
+{
+  ost << "[" << a.BaseLine->Nr << "|" << a.BaseLine->endpoints[0]->node->getName() << "," << a.BaseLine->endpoints[1]->node->getName() << "] with ";
+  if (a.pointlist.empty())
+    ost << "no candidate.";
+  else {
+    ost << "candidate";
+    if (a.pointlist.size() != 1)
+      ost << "s ";
+    else
+      ost << " ";
+    for (TesselPointList::const_iterator Runner = a.pointlist.begin(); Runner != a.pointlist.end(); Runner++)
+      ost << *(*Runner) << " ";
+    ost << " at angle " << (a.ShortestAngle) << ".";
+  }
+
+  return ost;
+}
+;
+
Index: src/CandidateForTesselation.hpp
===================================================================
--- src/CandidateForTesselation.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/CandidateForTesselation.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,48 @@
+/*
+ * CandidateForTesselation.hpp
+ *
+ *  Created on: Jul 29, 2010
+ *      Author: heber
+ */
+
+#ifndef CANDIDATEFORTESSELATION_HPP_
+#define CANDIDATEFORTESSELATION_HPP_
+
+#include "BoundaryMaps.hpp"
+#include "LinearAlgebra/Vector.hpp"
+
+#include <list>
+#include <set>
+
+class BoundaryLineSet;
+class BoundaryPointSet;
+class BoundaryTriangleSet;
+class LinkedCell;
+class TesselPoint;
+
+class CandidateForTesselation {
+  public :
+  CandidateForTesselation(BoundaryLineSet* currentBaseLine);
+  CandidateForTesselation(TesselPoint* candidate, BoundaryLineSet* currentBaseLine, BoundaryPointSet *point, const Vector &OptCandidateCenter, const Vector &OtherOptCandidateCenter);
+  ~CandidateForTesselation();
+
+  bool CheckValidity(const double RADIUS, const class LinkedCell *LC) const;
+
+  TesselPointList pointlist;
+  const BoundaryLineSet * BaseLine;
+  const BoundaryPointSet * ThirdPoint;
+  const BoundaryTriangleSet *T;
+  Vector OldCenter;
+  Vector OptCenter;
+  Vector OtherOptCenter;
+  double ShortestAngle;
+  double OtherShortestAngle;
+
+  private:
+  static const double HULLEPSILON; //!< TODO: Get rid of HULLEPSILON, points to numerical instabilities
+};
+
+std::ostream & operator <<(std::ostream &ost, const  CandidateForTesselation &a);
+
+
+#endif /* CANDIDATEFORTESSELATION_HPP_ */
Index: src/CommandLineParser.cpp
===================================================================
--- src/CommandLineParser.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/CommandLineParser.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -15,6 +20,6 @@
 #include "Patterns/Singleton_impl.hpp"
 #include "CommandLineParser.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 
 using namespace std;
@@ -41,5 +46,5 @@
 void CommandLineParser::Parse()
 {
-  po::store(po::command_line_parser(argc,argv).options(cmdline_options).options(visible).run(), vm);
+  po::store(po::command_line_parser(argc,argv).options(cmdline_options).run(), vm);
   ifstream input;
   input.open("example.cfg");
Index: src/ConfigFileBuffer.cpp
===================================================================
--- src/ConfigFileBuffer.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/ConfigFileBuffer.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,8 +6,16 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
 #include "ConfigFileBuffer.hpp"
-#include "helpers.hpp"
+#include "Helpers/helpers.hpp"
 #include "lists.hpp"
-#include "log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "Helpers/Log.hpp"
 #include "World.hpp"
 
@@ -50,5 +58,9 @@
 /** Constructor for ConfigFileBuffer class.
  */
-ConfigFileBuffer::ConfigFileBuffer() : buffer(NULL), LineMapping(NULL), CurrentLine(0), NoLines(0)
+ConfigFileBuffer::ConfigFileBuffer() :
+    buffer(NULL),
+    LineMapping(NULL),
+    CurrentLine(0),
+    NoLines(0)
 {
 };
@@ -57,5 +69,9 @@
  * \param *filename file name
  */
-ConfigFileBuffer::ConfigFileBuffer(const char * const filename) : buffer(NULL), LineMapping(NULL), CurrentLine(0), NoLines(0)
+ConfigFileBuffer::ConfigFileBuffer(const char * const filename) :
+    buffer(NULL),
+    LineMapping(NULL),
+    CurrentLine(0),
+    NoLines(0)
 {
   InitFileBuffer(filename);
Index: src/ConfigFileBuffer.hpp
===================================================================
--- src/ConfigFileBuffer.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/ConfigFileBuffer.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -17,5 +17,5 @@
 #endif
 
-#include <iostream>
+#include <iosfwd>
 
 /****************************************** forward declarations *****************************/
Index: src/Descriptors/AtomDescriptor.cpp
===================================================================
--- src/Descriptors/AtomDescriptor.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Descriptors/AtomDescriptor.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -13,4 +18,5 @@
 #include "World.hpp"
 #include "atom.hpp"
+#include "Patterns/ObservedContainer_impl.hpp"
 
 #include <boost/bind.hpp>
@@ -20,5 +26,5 @@
 using namespace std;
 
-typedef World::AtomSet::iterator atoms_iter_t;
+typedef World::AtomSet::internal_iterator atoms_iter_t;
 
 /************************ Forwarding object **************************************/
@@ -73,7 +79,7 @@
 
 atom* AtomDescriptor_impl::find() {
-  World::AtomSet atoms = getAtoms();
-  atoms_iter_t res = find_if(atoms.begin(),atoms.end(),boost::bind(&AtomDescriptor_impl::predicate,this,_1));
-  return (res!=atoms.end())?((*res).second):0;
+  World::AtomSet &atoms = getAtoms();
+  atoms_iter_t res = find_if(atoms.begin_internal(),atoms.end_internal(),boost::bind(&AtomDescriptor_impl::predicate,this,_1));
+  return (res!=atoms.end_internal())?((*res).second):0;
 }
 
@@ -81,11 +87,15 @@
   vector<atom*> res;
   World::AtomSet atoms = getAtoms();
-  atoms_iter_t iter;
-  for(iter=atoms.begin();iter!=atoms.end();++iter) {
-    if(predicate(*iter)){
-      res.push_back((*iter).second);
-    }
+  for_each(atoms.begin_internal(),
+           atoms.end_internal(),
+           boost::bind(&AtomDescriptor_impl::checkAndAdd,
+                       this,&res,_1));
+  return res;
+}
+
+void AtomDescriptor_impl::checkAndAdd(std::vector<atom*> *v,std::pair<atomId_t,atom*> p){
+  if(predicate(p)){
+    v->push_back(p.second);
   }
-  return res;
 }
 
Index: src/Descriptors/AtomDescriptor.hpp
===================================================================
--- src/Descriptors/AtomDescriptor.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Descriptors/AtomDescriptor.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -35,5 +35,5 @@
   // close coupling to the world to allow access
   friend atom* World::getAtom(AtomDescriptor descriptor);
-  friend std::vector<atom*> World::getAllAtoms(AtomDescriptor descriptor);
+  friend World::AtomComposite World::getAllAtoms(AtomDescriptor descriptor);
   template <class,class,class> friend class SelectiveIterator;
 
Index: src/Descriptors/AtomDescriptor_impl.hpp
===================================================================
--- src/Descriptors/AtomDescriptor_impl.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Descriptors/AtomDescriptor_impl.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -50,4 +50,6 @@
    */
   World::AtomSet& getAtoms();
+
+  void checkAndAdd(std::vector<atom*>*,std::pair<atomId_t,atom*>);
 };
 
Index: src/Descriptors/AtomIdDescriptor.cpp
===================================================================
--- src/Descriptors/AtomIdDescriptor.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Descriptors/AtomIdDescriptor.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,4 +6,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
@@ -12,4 +17,5 @@
 
 #include "atom.hpp"
+#include "Patterns/ObservedContainer_impl.hpp"
 
 using namespace std;
@@ -32,5 +38,5 @@
 
 atom *AtomIdDescriptor_impl::find(){
-  World::AtomSet atoms = getAtoms();
+  World::AtomSet &atoms = getAtoms();
   World::AtomSet::iterator res = atoms.find(id);
   return (res!=atoms.end())?((*res).second):0;
Index: src/Descriptors/AtomSelectionDescriptor.cpp
===================================================================
--- src/Descriptors/AtomSelectionDescriptor.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Descriptors/AtomSelectionDescriptor.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,50 @@
+/*
+ * AtomSelectionDescriptor.cpp
+ *
+ *  Created on: Jul 16, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Descriptors/AtomSelectionDescriptor.hpp"
+#include "Descriptors/AtomSelectionDescriptor_impl.hpp"
+
+#include "Helpers/helpers.hpp"
+
+AtomSelectionDescriptor_impl::AtomSelectionDescriptor_impl(){}
+
+AtomSelectionDescriptor_impl::~AtomSelectionDescriptor_impl(){}
+
+bool AtomSelectionDescriptor_impl::predicate(std::pair<atomId_t,atom*> atom){
+  return getSelectedAtoms().count(atom.first);
+}
+
+atom* AtomSelectionDescriptor_impl::find(){
+  World::AtomSet &set = getSelectedAtoms();
+  World::AtomSet::internal_iterator begin = set.begin_internal();
+  return (begin!=set.end_internal())?(begin->second):0;
+}
+
+std::vector<atom*> AtomSelectionDescriptor_impl::findAll(){
+  std::vector<atom*> res;
+  World::AtomSet &set = getSelectedAtoms();
+  transform(set.begin_internal(),
+           set.end_internal(),
+           back_inserter(res),
+           _take<atom*,World::AtomSet::value_type>::get);
+  return res;
+}
+
+World::AtomSet& AtomSelectionDescriptor_impl::getSelectedAtoms(){
+  return World::getInstance().selectedAtoms;
+}
+
+AtomDescriptor AtomsBySelection(){
+  return AtomDescriptor(AtomDescriptor::impl_ptr(new AtomSelectionDescriptor_impl()));
+}
Index: src/Descriptors/AtomSelectionDescriptor.hpp
===================================================================
--- src/Descriptors/AtomSelectionDescriptor.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Descriptors/AtomSelectionDescriptor.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,15 @@
+/*
+ * AtomSelectionDescriptor.hpp
+ *
+ *  Created on: Jul 16, 2010
+ *      Author: crueger
+ */
+
+#ifndef ATOMSELECTIONDESCRIPTOR_HPP_
+#define ATOMSELECTIONDESCRIPTOR_HPP_
+
+#include "Descriptors/AtomDescriptor.hpp"
+
+AtomDescriptor AtomsBySelection();
+
+#endif /* ATOMSELECTIONDESCRIPTOR_HPP_ */
Index: src/Descriptors/AtomSelectionDescriptor_impl.hpp
===================================================================
--- src/Descriptors/AtomSelectionDescriptor_impl.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Descriptors/AtomSelectionDescriptor_impl.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,26 @@
+/*
+ * AtomSelectionDescriptor_impl.hpp
+ *
+ *  Created on: Jul 16, 2010
+ *      Author: crueger
+ */
+
+#ifndef ATOMSELECTIONDESCRIPTOR_IMPL_HPP_
+#define ATOMSELECTIONDESCRIPTOR_IMPL_HPP_
+
+#include "Descriptors/AtomDescriptor_impl.hpp"
+
+class AtomSelectionDescriptor_impl : public AtomDescriptor_impl{
+public:
+  AtomSelectionDescriptor_impl();
+  virtual ~AtomSelectionDescriptor_impl();
+  bool predicate(std::pair<atomId_t,atom*> atom);
+protected:
+  // need to overide more than the standard methods to make this fast
+  virtual atom* find();
+  virtual std::vector<atom*> findAll();
+
+  World::AtomSet& getSelectedAtoms();
+};
+
+#endif /* ATOMSELECTIONDESCRIPTOR_IMPL_HPP_ */
Index: src/Descriptors/AtomShapeDescriptor.cpp
===================================================================
--- src/Descriptors/AtomShapeDescriptor.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Descriptors/AtomShapeDescriptor.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,38 @@
+/*
+ * AtomShapeDescriptor.cpp
+ *
+ *  Created on: Aug 9, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "AtomShapeDescriptor.hpp"
+#include "AtomShapeDescriptor_impl.hpp"
+
+#include "atom.hpp"
+#include "Patterns/ObservedContainer_impl.hpp"
+#include "Shapes/Shape.hpp"
+
+using namespace std;
+
+
+AtomShapeDescriptor_impl::AtomShapeDescriptor_impl(Shape _shape) :
+  shape(_shape)
+{}
+
+AtomShapeDescriptor_impl::~AtomShapeDescriptor_impl()
+{}
+
+bool AtomShapeDescriptor_impl::predicate(std::pair<atomId_t,atom*> atom) {
+  return shape.isInside(atom.second->getPosition());
+}
+
+AtomDescriptor AtomByShape(Shape &_shape){
+  return AtomDescriptor(AtomDescriptor::impl_ptr(new AtomShapeDescriptor_impl(_shape)));
+}
Index: src/Descriptors/AtomShapeDescriptor.hpp
===================================================================
--- src/Descriptors/AtomShapeDescriptor.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Descriptors/AtomShapeDescriptor.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,18 @@
+/*
+ * AtomShapeDescriptor.hpp
+ *
+ *  Created on: Aug 9, 2010
+ *      Author: heber
+ */
+
+#ifndef ATOMSHAPEDESCRIPTOR_HPP_
+#define ATOMSHAPEDESCRIPTOR_HPP_
+
+#include "defs.hpp"
+#include "Descriptors/AtomDescriptor.hpp"
+
+class Shape;
+
+AtomDescriptor AtomByShape(Shape &_shape);
+
+#endif /* ATOMSHAPEDESCRIPTOR_HPP_ */
Index: src/Descriptors/AtomShapeDescriptor_impl.hpp
===================================================================
--- src/Descriptors/AtomShapeDescriptor_impl.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Descriptors/AtomShapeDescriptor_impl.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,26 @@
+/*
+ * AtomShapeDescriptor_impl.hpp
+ *
+ *  Created on: Aug 9, 2010
+ *      Author: heber
+ */
+
+#ifndef ATOMSHAPEDESCRIPTOR_IMPL_HPP
+#define ATOMSHAPEDESCRIPTOR_IMPL_HPP
+
+#include "Descriptors/AtomDescriptor_impl.hpp"
+#include "Shapes/Shape.hpp"
+
+class AtomShapeDescriptor_impl : public AtomDescriptor_impl
+{
+public:
+  AtomShapeDescriptor_impl(Shape _shape);
+  virtual ~AtomShapeDescriptor_impl();
+
+  bool predicate(std::pair<atomId_t,atom*> atom);
+
+private:
+  Shape shape;
+};
+
+#endif //ATOMSHAPEDESCRIPTOR_IMPL_HPP
Index: src/Descriptors/AtomTypeDescriptor.cpp
===================================================================
--- src/Descriptors/AtomTypeDescriptor.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Descriptors/AtomTypeDescriptor.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/Descriptors/MoleculeDescriptor.cpp
===================================================================
--- src/Descriptors/MoleculeDescriptor.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Descriptors/MoleculeDescriptor.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,4 +6,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
@@ -12,4 +17,5 @@
 
 #include "World.hpp"
+#include "Patterns/ObservedContainer_impl.hpp"
 
 #include "molecule.hpp"
@@ -20,5 +26,5 @@
 using namespace std;
 
-typedef World::MoleculeSet::iterator molecules_iter_t;
+typedef World::MoleculeSet::internal_iterator molecules_iter_t;
 
 /************************ Forwarding object **************************************/
@@ -73,19 +79,23 @@
 
 molecule* MoleculeDescriptor_impl::find() {
-  World::MoleculeSet molecules = getMolecules();
-  molecules_iter_t res = find_if(molecules.begin(),molecules.end(),boost::bind(&MoleculeDescriptor_impl::predicate,this,_1));
-  return (res!=molecules.end())?((*res).second):0;
+  World::MoleculeSet &molecules = getMolecules();
+  molecules_iter_t res = find_if(molecules.begin_internal(),molecules.end_internal(),boost::bind(&MoleculeDescriptor_impl::predicate,this,_1));
+  return (res!=molecules.end_internal())?((*res).second):0;
 }
 
 vector<molecule*> MoleculeDescriptor_impl::findAll() {
   vector<molecule*> res;
-  World::MoleculeSet molecules = getMolecules();
-  molecules_iter_t iter;
-  for(iter=molecules.begin();iter!=molecules.end();++iter) {
-    if(predicate(*iter)){
-      res.push_back((*iter).second);
-    }
+  World::MoleculeSet &molecules = getMolecules();
+  for_each(molecules.begin_internal(),
+           molecules.end_internal(),
+           boost::bind(&MoleculeDescriptor_impl::checkAndAdd,
+                       this,&res,_1));
+  return res;
+}
+
+void MoleculeDescriptor_impl::checkAndAdd(std::vector<molecule*> *v,std::pair<moleculeId_t,molecule*> p){
+  if(predicate(p)){
+    v->push_back(p.second);
   }
-  return res;
 }
 
Index: src/Descriptors/MoleculeDescriptor_impl.hpp
===================================================================
--- src/Descriptors/MoleculeDescriptor_impl.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Descriptors/MoleculeDescriptor_impl.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -50,4 +50,6 @@
    */
   World::MoleculeSet& getMolecules();
+
+  void checkAndAdd(std::vector<molecule*>*,std::pair<moleculeId_t,molecule*>);
 };
 
Index: src/Descriptors/MoleculeFormulaDescriptor.cpp
===================================================================
--- src/Descriptors/MoleculeFormulaDescriptor.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Descriptors/MoleculeFormulaDescriptor.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,40 @@
+/*
+ * MoleculeFormulaDescriptor.cpp
+ *
+ *  Created on: Jul 22, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "MoleculeFormulaDescriptor.hpp"
+#include "MoleculeFormulaDescriptor_impl.hpp"
+
+#include "molecule.hpp"
+
+
+MoleculeFormulaDescriptor_impl::MoleculeFormulaDescriptor_impl(const Formula &_formula) :
+  formula(_formula)
+{}
+
+MoleculeFormulaDescriptor_impl::~MoleculeFormulaDescriptor_impl(){}
+
+bool MoleculeFormulaDescriptor_impl::predicate(std::pair<moleculeId_t,molecule*> molecule){
+  return molecule.second->getFormula() == formula;
+}
+
+
+MoleculeDescriptor MoleculeByFormula(const Formula &formula)
+{
+  return MoleculeDescriptor(MoleculeDescriptor::impl_ptr(new MoleculeFormulaDescriptor_impl(formula)));
+}
+
+MoleculeDescriptor MoleculeByFormula(const std::string &_formula) throw(ParseError){
+  Formula formula(_formula);
+  return MoleculeByFormula(formula);
+}
Index: src/Descriptors/MoleculeFormulaDescriptor.hpp
===================================================================
--- src/Descriptors/MoleculeFormulaDescriptor.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Descriptors/MoleculeFormulaDescriptor.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,19 @@
+/*
+ * MoleculeFormulaDescriptor.hpp
+ *
+ *  Created on: Jul 22, 2010
+ *      Author: crueger
+ */
+
+#ifndef MOLECULEFORMULADESCRIPTOR_HPP_
+#define MOLECULEFORMULADESCRIPTOR_HPP_
+
+#include "Descriptors/MoleculeDescriptor.hpp"
+#include "Exceptions/ParseError.hpp"
+
+class Formula;
+
+MoleculeDescriptor MoleculeByFormula(const Formula&);
+MoleculeDescriptor MoleculeByFormula(const std::string&) throw(ParseError);
+
+#endif /* MOLECULEFORMULADESCRIPTOR_HPP_ */
Index: src/Descriptors/MoleculeFormulaDescriptor_impl.hpp
===================================================================
--- src/Descriptors/MoleculeFormulaDescriptor_impl.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Descriptors/MoleculeFormulaDescriptor_impl.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,24 @@
+/*
+ * MoleculeFormulaDescriptor_impl.hpp
+ *
+ *  Created on: Jul 22, 2010
+ *      Author: crueger
+ */
+
+#ifndef MOLECULEFORMULADESCRIPTOR_IMPL_HPP_
+#define MOLECULEFORMULADESCRIPTOR_IMPL_HPP_
+
+#include "Descriptors/MoleculeDescriptor_impl.hpp"
+#include "Formula.hpp"
+
+class MoleculeFormulaDescriptor_impl : public MoleculeDescriptor_impl
+{
+public:
+  MoleculeFormulaDescriptor_impl(const Formula &);
+  virtual ~MoleculeFormulaDescriptor_impl();
+  bool predicate(std::pair<moleculeId_t,molecule*> molecule);
+private:
+  Formula formula;
+};
+
+#endif /* MOLECULEFORMULADESCRIPTOR_IMPL_HPP_ */
